C++实现LeetCode(62.不同的路径)

[LeetCode] 62. Unique Paths 不同的路径

A robot is located at the top-left corner of a m x n grid (marked ‘Start’ in the diagram below).

The robot can only move either down or right at any point in time. The robot is trying to reach the bottom-right corner of the grid (marked ‘Finish’ in the diagram below).

How many possible unique paths are there?

Above is a 7 x 3 grid. How many possible unique paths are there?

Note: m and n will be at most 100.

Example 1:

Input: m = 3, n = 2Output: 3Explanation:From the top-left corner, there are a total of 3 ways to reach the bottom-right corner:1. Right -> Right -> Down2. Right -> Down -> Right3. Down -> Right -> Right

Example 2:

Input: m = 7, n = 3Output: 28

这道题让求所有不同的路径的个数,一开始还真把博主难住了,因为之前好像没有遇到过这类的问题,所以感觉好像有种无从下手的感觉。在网上找攻略之后才恍然大悟,原来这跟之前那道 Climbing Stairs 很类似,那道题是说可以每次能爬一格或两格,问到达顶部的所有不同爬法的个数。而这道题是每次可以向下走或者向右走,求到达最右下角的所有不同走法的个数。那么跟爬梯子问题一样,需要用动态规划 Dynamic Programming 来解,可以维护一个二维数组 dp,其中 dp[i][j] 表示到当前位置不同的走法的个数,然后可以得到状态转移方程为:  dp[i][j] = dp[i – 1][j] + dp[i][j – 1],这里为了节省空间,使用一维数组 dp,一行一行的刷新也可以,代码如下:

解法一:

class Solution {public:    int uniquePaths(int m, int n) {        vector<int> dp(n, 1);        for (int i = 1; i < m; ++i) {            for (int j = 1; j < n; ++j) {                dp[j] += dp[j - 1];             }        }        return dp[n - 1];    }};

这道题其实还有另一种很数学的解法,实际相当于机器人总共走了 m + n – 2步,其中 m – 1 步向右走,n – 1 步向下走,那么总共不同的方法个数就相当于在步数里面 m – 1 和 n – 1 中较小的那个数的取法,实际上是一道组合数的问题,写出代码如下:

解法二:

class Solution {public:    int uniquePaths(int m, int n) {        double num = 1, denom = 1;        int small = m > n ? n : m;        for (int i = 1; i <= small - 1; ++i) {            num *= m + n - 1 - i;            denom *= i;        }        return (int)(num / denom);    }};

到此这篇关于C++实现LeetCode(62.不同的路径)的文章就介绍到这了,更多相关C++实现不同的路径内容请搜索以前的文章或继续浏览下面的相关文章希望大家以后多多支持!

今天不想走,明天就要跑了。

C++实现LeetCode(62.不同的路径)

相关文章:

你感兴趣的文章:

标签云: